// Stack.java

public class Stack<E extends Number>
{
   private E[] elements;
   private int top;

   @SuppressWarnings("unchecked")
   public Stack(int size)
   {
      elements = (E[]) new Number[size];
      top = -1;
   }

   public void push(E element) throws StackFullException
   {
      if (top == elements.length-1)
         throw new StackFullException();
      elements[++top] = element;
   }

   E pop() throws StackEmptyException
   {
      if (isEmpty())
         throw new StackEmptyException();
      return elements[top--];
   }

   public boolean isEmpty()
   {
      return top == -1;
   }

   public static void main(String[] args)
      throws StackFullException, StackEmptyException
   {
      Stack<Number> stack = new Stack<Number>(5);
      stack.push(1);
      stack.push(2.5);

      while (!stack.isEmpty())
         System.out.println(stack.pop());
   }
}

class StackEmptyException extends Exception
{
}

class StackFullException extends Exception
{
}
